<?php
	/*
	 *		PSTN Class to Wizard Modal
	 *
	 */

class PstnWizard
{
	// main variables
	var $nb_lif	    = 0;
	var $which_scenario = 1;

	var $tones_loaded = array();
	var $file_tones   = '/usr/conf/isgw.tones';

	var $t1e1  = false  ;
	var $types = array();
	var $ports = array();
	var $start = array();
	var $lifs  = array();
	var $list_port_types = array();

	var $pri_wizard = 'pri-wizard';
	var $bri_wizard = 'bri-wizard';
	var $gsm_wizard = 'gsm-wizard';
	var $lte_wizard = 'lte-wizard';
	var $fxs_wizard = 'fxs-wizard';
	var $fxo_wizard = 'fxo-wizard';

	var $port_types = array('id' => 'port-types', 'name' => 'port_types', 'title' => WIZARD_PSTN_PORT_TYPE_DIS, 'tooltip' => '');

	// PRI
	var $pri_group	 = array('id' => 'pri-group'   , 'name' => 'pri_group'	 , 'title' => PSTN_NAME_DIS   	     	 , 'tooltip' => ISDN_GROUP_NAME 	, 'type' => 'text'    );
	var $pri_ports	 = array('id' => 'pri-ports'   , 'name' => 'pri_ports[]' , 'title' => PSTN_PORTS_DIS  	     	 , 'tooltip' => ISDN_PORTS_TABLE	, 'type' => 'checkbox');
	var $pri_ntte	 = array('id' => 'pri-ntte'    , 'name' => 'pri_ntte'	 , 'title' => HARDWARE_INTERFACE_TYPE_DIS, 'tooltip' => ISDNHW_MODE		, 'type' => 'select'  );
	var $pri_ptp	 = array('id' => 'pri-ptp'     , 'name' => 'pri_ptp'	 , 'title' => HARDWARE_PROTOCOL_DIS   	 , 'tooltip' => ISDNHW_PTP		, 'type' => 'hidden'  );
	var $pri_t1e1	 = array('id' => 'pri-t1e1'    , 'name' => 'pri_t1e1'	 , 'title' => HARDWARE_PROTOCOL_DIS    	 , 'tooltip' => ISDNHW_PTPE1		, 'type' => 'select'  );
	var $pri_tones	 = array('id' => 'pri-tones'   , 'name' => 'pri_tones'	 , 'title' => PSTN_TONES_DIS  	     	 , 'tooltip' => ISDN_TONES		, 'type' => 'select'  );
	var $pri_country = array('id' => 'pri-country' , 'name' => 'pri_country' , 'title' => PSTN_COUNTRY_CODE_DIS   	 , 'tooltip' => WIZARD_COUNTRY_CODE	, 'type' => 'text'    );
	var $pri_city	 = array('id' => 'pri-city'    , 'name' => 'pri_city'	 , 'title' => PSTN_CITY_CODE_DIS      	 , 'tooltip' => WIZARD_CITY_CODE	, 'type' => 'text'    );
	var $pri_local	 = array('id' => 'pri-local'   , 'name' => 'pri_local'	 , 'title' => PSTN_LOCAL_AREA_CODE_DIS	 , 'tooltip' => WIZARD_LOCAL_AREA_CODE	, 'type' => 'text'    );
	var $pri_user	 = array('id' => 'pri-user'    , 'name' => 'pri_user'	 , 'title' => SIP_USER_DIS    	     	 , 'tooltip' => TRUNKS_SIP_USER		, 'type' => 'text'    );
	var $pri_secret	 = array('id' => 'pri-secret'  , 'name' => 'pri_secret'	 , 'title' => SIP_SECRET_DIS  	     	 , 'tooltip' => TRUNKS_SIP_SECRET	, 'type' => 'password');
	var $pri_register= array('id' => 'pri-register', 'name' => 'pri_register', 'title' => SIP_REGISTER_DIS      	 , 'tooltip' => ''			, 'type' => 'hidden'  );

	// BRI 
	var $bri_group	 = array('id' => 'bri-group'   , 'name' => 'bri_group'	 , 'title' => PSTN_NAME_DIS   	     	 , 'tooltip' => ISDN_GROUP_NAME 	, 'type' => 'text'    );
	var $bri_ports	 = array('id' => 'bri-ports'   , 'name' => 'bri_ports[]'  , 'title' => PSTN_PORTS_DIS  	     	 , 'tooltip' => ISDN_PORTS_TABLE	, 'type' => 'checkbox');
	var $bri_ntte	 = array('id' => 'bri-ntte'    , 'name' => 'bri_ntte'	 , 'title' => HARDWARE_INTERFACE_TYPE_DIS, 'tooltip' => ISDNHW_MODE		, 'type' => 'hidden'  );
	var $bri_ptp	 = array('id' => 'bri-ptp'     , 'name' => 'bri_ptp'	 , 'title' => HARDWARE_PROTOCOL_DIS   	 , 'tooltip' => ISDNHW_PTP		, 'type' => 'select'  );
	var $bri_tones	 = array('id' => 'bri-tones'   , 'name' => 'bri_tones'	 , 'title' => PSTN_TONES_DIS  	     	 , 'tooltip' => ISDN_TONES		, 'type' => 'select'  );
	var $bri_country = array('id' => 'bri-country' , 'name' => 'bri_country' , 'title' => PSTN_COUNTRY_CODE_DIS   	 , 'tooltip' => WIZARD_COUNTRY_CODE	, 'type' => 'text'    );
	var $bri_city	 = array('id' => 'bri-city'    , 'name' => 'bri_city'	 , 'title' => PSTN_CITY_CODE_DIS      	 , 'tooltip' => WIZARD_CITY_CODE	, 'type' => 'text'    );
	var $bri_local	 = array('id' => 'bri-local'   , 'name' => 'bri_local'	 , 'title' => PSTN_LOCAL_AREA_CODE_DIS	 , 'tooltip' => WIZARD_LOCAL_AREA_CODE	, 'type' => 'text'    );
	var $bri_user	 = array('id' => 'bri-user'    , 'name' => 'bri_user'	 , 'title' => SIP_USER_DIS    	     	 , 'tooltip' => TRUNKS_SIP_USER		, 'type' => 'text'    );
	var $bri_secret	 = array('id' => 'bri-secret'  , 'name' => 'bri_secret'	 , 'title' => SIP_SECRET_DIS  	     	 , 'tooltip' => TRUNKS_SIP_SECRET	, 'type' => 'password');
	var $bri_register= array('id' => 'bri-register', 'name' => 'bri_register', 'title' => SIP_REGISTER_DIS  	 , 'tooltip' => ''			, 'type' => 'hidden'  );

	// GSM
	var $gsm_group	 = array('id' => 'gsm-group'   , 'name' => 'gsm_group'	 , 'title' => PSTN_NAME_DIS   , 'tooltip' => GSM_GROUP_NAME  	, 'type' => 'text'    );
	var $gsm_ports	 = array('id' => 'gsm-ports'   , 'name' => 'gsm_ports[]' , 'title' => PSTN_PORTS_DIS  , 'tooltip' => GSM_PORTS_TABLE 	, 'type' => 'checkbox');
	var $gsm_user	 = array('id' => 'gsm-user'    , 'name' => 'gsm_user'	 , 'title' => SIP_USER_DIS    , 'tooltip' => TRUNKS_SIP_USER  	, 'type' => 'text'    );
	var $gsm_secret	 = array('id' => 'gsm-secret'  , 'name' => 'gsm_secret'	 , 'title' => SIP_SECRET_DIS  , 'tooltip' => TRUNKS_SIP_SECRET	, 'type' => 'password');
	var $gsm_register= array('id' => 'gsm-register', 'name' => 'gsm_register', 'title' => SIP_REGISTER_DIS, 'tooltip' => ''		   	, 'type' => 'hidden'  );

	// LTE 
	var $lte_group	 = array('id' => 'lte-group'   , 'name' => 'lte_group'	 , 'title' => PSTN_NAME_DIS   , 'tooltip' => LTE_GROUP_NAME  	, 'type' => 'text'    );
	var $lte_ports	 = array('id' => 'lte-ports'   , 'name' => 'lte_ports[]' , 'title' => PSTN_PORTS_DIS  , 'tooltip' => LTE_PORTS_TABLE 	, 'type' => 'checkbox');
	var $lte_user	 = array('id' => 'lte-user'    , 'name' => 'lte_user'	 , 'title' => SIP_USER_DIS    , 'tooltip' => TRUNKS_SIP_USER  	, 'type' => 'text'    );
	var $lte_secret	 = array('id' => 'lte-secret'  , 'name' => 'lte_secret'	 , 'title' => SIP_SECRET_DIS  , 'tooltip' => TRUNKS_SIP_SECRET	, 'type' => 'password');
	var $lte_register= array('id' => 'lte-register', 'name' => 'lte_register', 'title' => SIP_REGISTER_DIS, 'tooltip' => ''		   	, 'type' => 'hidden'  );

	// FXS	
	var $fxs_group	 = array('id' => 'fxs-group'   , 'name' => 'fxs_group'	 , 'title' => PSTN_NAME_DIS   , 'tooltip' => ANALOG_GROUP_NAME 	, 'type' => 'text'    );
	var $fxs_ports	 = array('id' => 'fxs-ports'   , 'name' => 'fxs_ports[]' , 'title' => PSTN_PORTS_DIS  , 'tooltip' => ANALOG_PORTS_TABLE	, 'type' => 'checkbox');
	var $fxs_tones	 = array('id' => 'fxs-tones'   , 'name' => 'fxs_tones'	 , 'title' => PSTN_TONES_DIS  , 'tooltip' => ANALOG_TONES	, 'type' => 'text'    );
	var $fxs_user	 = array('id' => 'fxs-user'    , 'name' => 'fxs_user'	 , 'title' => SIP_USER_DIS    , 'tooltip' => TRUNKS_SIP_USER	, 'type' => 'text'    );
	var $fxs_secret	 = array('id' => 'fxs-secret'  , 'name' => 'fxs_secret'	 , 'title' => SIP_SECRET_DIS  , 'tooltip' => TRUNKS_SIP_SECRET	, 'type' => 'password');
	var $fxs_register= array('id' => 'fxs-register', 'name' => 'fxs_register', 'title' => SIP_REGISTER_DIS, 'tooltip' => ''			, 'type' => 'hidden'  );
	var $fxs_csvfile = array('id' => 'fxs-csvfile' , 'name' => 'fxs_csvfile' , 'title' => ''	      , 'tooltip' => ''			, 'type' => 'hidden'  );

	// FXO
	var $fxo_group	 = array('id' => 'fxo-group'   , 'name' => 'fxo_group'	 , 'title' => PSTN_NAME_DIS   , 'tooltip' => ANALOG_GROUP_NAME 	, 'type' => 'text'    );
	var $fxo_ports	 = array('id' => 'fxo-ports'   , 'name' => 'fxo_ports[]' , 'title' => PSTN_PORTS_DIS  , 'tooltip' => ANALOG_PORTS_TABLE	, 'type' => 'checkbox');
	var $fxo_tones	 = array('id' => 'fxo-tones'   , 'name' => 'fxo_tones'	 , 'title' => PSTN_TONES_DIS  , 'tooltip' => ANALOG_TONES	, 'type' => 'text'    );
	var $fxo_user	 = array('id' => 'fxo-user'    , 'name' => 'fxo_user'	 , 'title' => SIP_USER_DIS    , 'tooltip' => TRUNKS_SIP_USER	, 'type' => 'text'    );
	var $fxo_secret	 = array('id' => 'fxo-secret'  , 'name' => 'fxo_secret'	 , 'title' => SIP_SECRET_DIS  , 'tooltip' => TRUNKS_SIP_SECRET	, 'type' => 'password');
	var $fxo_register= array('id' => 'fxo-register', 'name' => 'fxo_register', 'title' => SIP_REGISTER_DIS, 'tooltip' => ''			, 'type' => 'hidden'  );

	// buttons to multiple module managment
	var $class_btns = 'multiple-modules';

	var $save_btn = array('id' => 'save-multiple', 'name' => 'save_multiple[]', 'value' => 'Save'  );
	var $updt_btn = array('id' => 'updt-multiple', 'name' => 'updt_multiple[]', 'value' => 'Update');
	var $rmve_btn = array('id' => 'rmve-multiple', 'name' => 'rmve_multiple[]', 'value' => 'Remove');

	function __construct($scenario = 1, $init = true)
	{
		$this -> which_scenario = $scenario;

		if ($init)
		{
			$this -> _lifs_info();

			// get main port types
			$this -> list_port_types = $this -> types;
			if (in_array('BRIFXS', $this -> list_port_types))
			{
				$this -> list_port_types[] = 'BRI';
				$this -> list_port_types[] = 'FXS';
	
				$key_brifxs = array_search('BRIFXS', $this -> list_port_types);
				unset($this -> list_port_types[$key_brifxs]);
			}
			$this -> list_port_types = array_unique($this -> list_port_types);

			// remove unknown from list_port_types
			if (($key_unkn = array_search('unknown', $this -> list_port_types)) !== false)
			{
				unset($this -> list_port_types[$key_unkn]);
			}

			// load tones from file
			if (file_exists($this -> file_tones))
			{
                		exec('/bin/cat '. $this -> file_tones .' | /bin/grep "^\[.*\]$" ', $this -> tones_loaded);
			}
		}
	}

	// private
/* General Functions */
	function _lifs_info ()
	{
		require_once('./includes/Helper/Helper.php');

		$lif 		= Helper::getLif();
		$this -> nb_lif = Helper::getLifCount();

		for ($i = 0; $i < $this -> nb_lif; $i++) 
		{
			$this -> lifs[$i]  = $lif[$i];
			$this -> ports[$i] = substr($lif[$i], 2, 1);

			switch(substr($lif[$i], 3))
			{
				case "S0":
					$this -> types[$i] = "BRI";
					$this -> start[$i] = "isdn";
					break;
				case "t1e1":
					$this -> t1e1 = true;
				case "E1":
					$this -> types[$i] = "PRI";
					$this -> start[$i] = "isdn";
					break;
				case "S02FXS":
					$this -> types[$i] = "BRIFXS";
					$this -> start[$i] = "isdn/analog";
					break;
				case "FXS":
					$this -> types[$i] = "FXS";
					$this -> start[$i] = "analog";
					break;
				case "FXO":
					$this -> types[$i] = "FXO";
					$this -> start[$i] = "analog";
					break;
				case "GSM":
					$this -> types[$i] = "GSM";
					$this -> start[$i] = "gsm";
					break;
				case "LTE":
					$this -> types[$i] = "LTE";
					$this -> start[$i] = "lte";
					break;
				default:
					$this -> types[$i] = "unknown";
					$this -> start[$i] = "n";
					break;
			}
		}
	}

        function _tones ($port_type, $name, $id, $tones, $disabled, $extern = '', $port = '', $tab = "\t\t\t\t\t\t")
	{
                $select = $tab. "<select class=\"form-control input-sm $extern$port_type$port\" name=\"$name\" id=\"$id\"$disabled>\n";

                foreach ($this -> tones_loaded as $value) 
		{
                        if ($tones == "") 
			{
                                if ($value == "[de]") 
				{
                                        $select .= $tab. "\t<option value=\"" . $value . "\" selected>" . $value . "</option>\n";
                                } 
				else if ($value != "[general]") 
				{
                                        $select .= $tab. "\t<option value=\"" . $value . "\">" . $value . "</option>\n";
                                }
                        } 
			else 
			{
                                if ($value == "[$tones]") 
				{
                                        $select .= $tab. "\t<option value=\"" . $value . "\" selected>" . $value . "</option>\n";
                                } 
				else if ($value != "[general]") 
				{
                                        $select .= $tab. "\t<option value=\"" . $value . "\">" . $value . "</option>\n";
                                }
                        }
                }

                $select .= $tab. "\t</select>\n";
                return $select;
        }

	function _get_pstn_id_from_port_type ($port_type)
	{
		switch ($port_type)
		{
			case 'PRI':
				return $this -> pri_wizard;
			case 'BRI':
				return $this -> bri_wizard;
			case 'GSM':
				return $this -> gsm_wizard;
			case 'FXO':
				return $this -> fxo_wizard;
			case 'FXS':
				return $this -> fxs_wizard;
			case 'LTE':
				return $this -> lte_wizard;
			default:
				return 'error';
		}
	}

	function _display_content ($pstn_cfg, $port_type)
	{
		switch ($port_type)
		{
			case 'PRI':
				$html_str = $this -> _display_content_pri($pstn_cfg);
				break;
			case 'BRI':
				$html_str = $this -> _display_content_bri($pstn_cfg);
				break;
			case 'GSM':
				$html_str = $this -> _display_content_gsm($pstn_cfg);
				break;
			case 'LTE':
				$html_str = $this -> _display_content_lte($pstn_cfg);
				break;
			case 'FXO':
				$html_str = $this -> _display_content_fxo($pstn_cfg);
				break;
			case 'FXS':
				$html_str = $this -> _display_content_fxs($pstn_cfg);
				break;
		}

		if ($this -> which_scenario == 2)
		{
			$html_str .= $this -> _add_buttons_to_multiple_module_management($port_type);	
		}

		return $html_str;
	}

	function _display_simple_select ($parameter, $options, $port_type, $tab = "\t\t\t\t")
	{
		$options_str = '';
		foreach ($options as $option)
		{
			$options_str .= $tab. "\t\t\t<option size='40' value='{$option['value']}'{$option['selected']}>{$option['value']}</option>\n";
		}

		return	  $tab. "<div class='form-group' data-toggle='tooltip' title='{$parameter['tooltip']}'>\n"
			. $tab. "\t<label class='col-sm-3 control-label' for='{$parameter['id']}-for'>{$parameter['title']}</label>\n"
			. $tab. "\t<div class='col-sm-8'>\n"
			. $tab. "\t\t<select class='form-control input-sm $port_type' name='{$parameter['name']}' id='{$parameter['id']}'>\n" 
			. $options_str 
			. $tab. "\t\t</select>\n"
			. $tab. "\t</div>\n"
			. $tab. "</div>\n";
	}

	function _display_simple_field ($port_type, $id, $name, $title, $type, $tooltip, $value, $tab = "\t\t\t\t")
	{
		return 	  $tab. "<div class='form-group' data-toggle='tooltip' title='$tooltip'>\n"
			. $tab. "\t<label for='$name' class='col-sm-3 control-label'>$title</label>\n"
			. $tab. "\t<div class='col-sm-8'>\n"
			. $tab. "\t\t<input type='$type' class='form-control input-sm $port_type' name='$name' id='$id' value='$value'>\n"
			. $tab. "\t</div>\n"
			. $tab. "</div>\n";		
	}

	function _display_tones ($id, $name, $title, $tooltip, $port_type, $tones, $disabled = '', $tab = "\t\t\t\t")
	{
		if (file_exists($this -> file_tones))
		{
			return	  $tab. "<div class='form-group' data-toggle='tooltip' title='$tooltip'>\n"
				. $tab. "\t<label for='$name' class='col-sm-3 control-label'>$title</label>\n"
				. $tab. "\t<div class='col-sm-8'>\n" 
				. $this -> _tones($port_type, $name, $id, $tones, $disabled)
				. $tab. "\t</div>\n"
				. $tab. "</div>\n";
		}

		return '';
	}

	function _display_ports_field ($pstn_cfg, $ports, $port_type, $parameter, $techno, $boolOnchange = false, $tab = "\t\t\t\t")
	{
		$title 	    = '';
		$line_ports = '';
		 
		$header_ports =   $tab. "<div class='form-group' id='{$parameter['id']}-tr'>\n"
				. $tab. "\t<label for='{$parameter['name']}' class='col-sm-3 control-label'>{$parameter['title']}</label>\n"
				. $tab. "\t<div class='col-sm-8'>\n";

		$nb_ports   = 0;
		$start_ports = 1;
		for ($i = 0; $i < $this -> nb_lif; $i++)
		{
			if (preg_match("#$port_type#", $this -> types[$i]))
			{
				$nb_ports += $this -> ports[$i];

				$line_ports .= 	  $tab. "\t\t<div>\n"
						. $tab. "\t\t\tLi$i ({$this -> lifs[$i]}) : \n"
						. $this -> _display_ports($pstn_cfg, $port_type, $start_ports, $nb_ports, $parameter, $ports, $boolOnchange, $techno) 
						. $tab. "\t\t</div>\n";

				$start_ports = $nb_ports + 1;
			}
		}

		return 	  $header_ports
			. $line_ports
			. $tab. "\t</div>\n"
			. $tab. "</div>\n";
	}

	function _display_ports ($pstn_cfg, $port_type, $start_ports, $nb_ports, $parameter, $array_checked_ports, $boolOnchange, $techno, $tab = "\t\t\t\t\t\t\t") 
	{
		$html_str = '';

		for ($i = $start_ports; $i <= $nb_ports; $i++)
		{
			// update onchange (only for BRI module)
			$onchange = '';
			if ($boolOnchange)
			{
				$onchange = " onchange=\"switch_bri_port('$i', 1);\"";
			}

			// update checked if the port used by an intern port or not used
			$checked  = ' checked';
			if ((count($array_checked_ports) > 0 && !(in_array($i, $array_checked_ports))) || isset($pstn_cfg['intern_'. strtolower($port_type) .'_group_'. $i]))
			{
				$checked = '';
			}

			$html_str .= $tab. "<input type='{$parameter['type']}' class='$port_type' name='{$parameter['name']}' id='{$parameter['id']}-$i' value='$i'$checked$onchange>Port $i\n";
		}

		return $html_str;
	}

	function _intern_port_line ($port_type, $type_cfg, $ports, $group, $register, $user, $secret, $tones, $hardware, $protocol, $start_ports, $nb_ports, $intern = 'intern', $tab = "\t\t\t\t")
	{
		$table = '';

		$booleanConfigHdw = false;
		if (isset($hardware['id']))
		{
			// only the BRI module with intern ports must be configured
			$booleanConfigHdw = true;
		}

		$booleanFileTones = file_exists($this -> file_tones);

		for ($i = $start_ports; $i <= $nb_ports; $i++)
		{
			$id_extern_port = $ports['id'] ."-$i";
			
			$checked    = '';
			$disabled   = ' disabled';
			if (isset($type_cfg["{$intern}_". strtolower($port_type) ."_group_$i"]))
			{
				$checked     = ' checked';
				$disabled    = '';
			}

			$user_value   = (isset($type_cfg["{$intern}_{$user['name']}_$i"]) ? $type_cfg["{$intern}_{$user['name']}_$i"] : '');
			$user_tooltip = "data-toggle='tooltip' title='{$user['tooltip']}'";

			$secret_value   = (isset($type_cfg["{$intern}_{$secret['name']}_$i"]) ? $type_cfg["{$intern}_{$secret['name']}_$i"] : '');
			$secret_tooltip = "data-toggle='tooltip' title='{$secret['tooltip']}'";

			$onchange  = ($booleanConfigHdw ? " onclick=\"switch_bri_port('$i', 0);\"" : " onclick=\"switch_fxs_port('$i');\"");
			$hdw_str   = ($booleanConfigHdw ? $tab. "\t\t\t\t<input type='hidden' class='form-control input-sm $intern-$port_type-$i' name='{$intern}_{$hardware['name']}_$i' id='$intern-{$hardware['id']}-$i' value='nt'>\n" : '');
			$prtcl_str = ($booleanConfigHdw ? $tab. "\t\t\t\t<input type='hidden' class='form-control input-sm $intern-$port_type-$i' name='{$intern}_{$protocol['name']}_$i' id='$intern-{$protocol['id']}-$i' value='PMP'>\n" : '');

			$table .= $tab. "<div class='row'>\n"
				. $tab. "\t<div class='col-sm-3'>\n"
				. $tab. "\t\t<div class='form-group'>\n"
				. $tab. "\t\t\t<label for='$intern-{$ports['id']}-$i' class='col-sm-2 control-label'>$i</label>\n"
				. $tab. "\t\t\t<div class='col-sm-5'>\n"
				. $tab. "\t\t\t\t<input type='hidden' class='form-control input-sm $intern-$port_type-$i' name='{$intern}_{$register['name']}_$i' id='$intern-{$register['id']}-$i' value='1'>\n"
				. $hdw_str 
				. $prtcl_str
				. $tab. "\t\t\t\t<input type='hidden' class='form-control input-sm $intern-$port_type-$i' name='$intern". "_". $group['name']    ."_$i' id='$intern-{$group['id']}-$i' value='$port_type-$intern-$i'>\n"
				. $tab. "\t\t\t\t<input type='{$ports['type']}' class='$intern-$port_type-$i' name='{$intern}_{$ports['name']}_$i' id='$intern-{$ports['id']}-$i' value='$i'$onchange$checked>\n"
				. $tab. "\t\t\t</div>\n"
				. $tab. "\t\t</div>\n"
				. $tab. "\t</div>\n"
				. $tab. "\t<div class='col-sm-3'>\n"
				. $tab. "\t\t<input type='{$user['type']}' class='form-control input-sm $intern-$port_type-$i' $user_tooltip name='{$intern}_{$user['name']}_$i' id='$intern-{$user['id']}-$i' value='$user_value'$disabled>\n"
				. $tab. "\t</div>\n"
				. $tab. "\t<div class='col-sm-3'>\n"
				. $tab. "\t\t<input type='{$secret['type']}' class='form-control input-sm $intern-$port_type-$i' $secret_tooltip name='{$intern}_{$secret['name']}_$i' id='$intern-{$secret['id']}-$i' value='$secret_value'$disabled>\n"
				. $tab. "\t</div>\n";

			if ($booleanFileTones)
			{
				$tones_value = (isset($type_cfg["{$intern}_{$tones['name']}_$i"]) ? $type_cfg["{$intern}_{$tones['name']}_$i"] : '');

				$table .= $tab. "\t<div class='col-sm-3'>\n"
        				. $this -> _tones($port_type, "{$intern}_{$tones['name']}_$i", "$intern-{$tones['id']}-$i", $tones_value, $disabled, "$intern-", "-$i")
					. $tab. "\t</div>\n";
			}
		
			$table .= $tab. "</div>\n";
		}

		return $table;
	}

	function _add_buttons_to_multiple_module_management ($port_type, $tab = "\t\t\t\t")
	{
		return    $tab. "<div class='{$this -> class_btns} $port_type' style='text-align: center;'>\n"
			. $tab. $this -> get_save_button($port_type) ."\n"
			. $tab. "</div>\n";
	}

/* get required input (jquery validator */
	function _get_port_depends ($ports_id, $ports_name, $port_type)
	{
		ob_start();
?>
							depends: function () {
								var uniquePorts = [];
								
								for (var typeNode of document.getElementsByName('<?php echo $ports_name; ?>').values())
								{
									var port = typeNode.id.slice(-1);
 									if (uniquePorts.indexOf(port) == -1)
									{
										if ($('#<?php echo $ports_id; ?>-' + port).is(':checked'))
										{
											return true;
										}
										uniquePorts.push(port);
									}
								}

								$('.<?php echo $port_type; ?>').prop('value', '');
								$('.<?php echo $port_type; ?>').prop('checked', false);
								$('.form-control.input-sm.<?php echo $port_type; ?>').prop('value', '');

								return false;
							}
<?php
		return ob_get_clean();
	}

	function _get_validator_input_group ($group_name, $port_depends = '', $tab = "\t\t\t\t\t")
	{
		$required = "true,\n";
		if (strlen($port_depends) > 0)
		{
			$required =	  "{\n"
					. $port_depends
					. $tab. "\t},\n";
		}

		return 	  $tab. "'$group_name': {\n"
			. $tab. "\trequired: $required"
			. $tab. "\tcheckDigChar: $required"
			. $tab. "},\n";
	}

	function _get_validator_input_ports ($ports_name, $tab = "\t\t\t\t\t")
	{
	 	return	  $tab. "'$ports_name': {\n"
		  	. $tab. "\tatLeastOnePortWizard: true,\n"
			. $tab. "},\n";
	}

	function _get_validator_input_country ($country_name, $tab = "\t\t\t\t\t")
	{
		$required = '';
		if ($this -> which_scenario == 3)
		{
			$required = $tab. "\trequired: true,\n";
		}

		return 	  $tab. "'$country_name': {\n"
			. $required
			. $tab. "\tcheckPhoneNumber: true,\n"
			. $tab. "},\n";
	}

	function _get_validator_input_city ($city_name, $tab = "\t\t\t\t\t")
	{
		$required = '';
		if ($this -> which_scenario == 3)
		{
			$required = $tab. "\trequired: true,\n";
		}
	
		return	  $tab. "'$city_name': {\n"
			. $required
			. $tab. "\tdigits: true,\n"
			. $tab. "},\n";
	}

	function _get_validator_input_local ($local_name, $tab = "\t\t\t\t\t")
	{
		return	  $tab. "'$local_name': {\n"
			. $tab. "\tdigits: true,\n"
			. $tab. "},\n";
	}

/* display intern html code */
	function _display_intern_table_ports ($port_type, $type_cfg, $ports, $group, $register, $user, $secret, $tones, $hardware = array(), $protocol = array(), $tab = "\t\t\t\t")
	{
		$table =  $tab. "<div class='row'>\n"
			. $tab. "\t<div class='col-sm-3'><strong>". $ports['title']  ."</strong></div>\n"
			. $tab. "\t<div class='col-sm-3'><strong>". $user['title']   ."</strong></div>\n"
			. $tab. "\t<div class='col-sm-3'><strong>". $secret['title'] ."</strong></div>\n"
			. $tab. "\t<div class='col-sm-3'><strong>". $tones['title']  ."</strong></div>\n"
			. $tab. "</div>\n";
	
		$nb_ports    = 0;
		$start_ports = 1;
		for ($i = 0; $i < $this -> nb_lif; $i++)
		{
			if (preg_match("#$port_type#", $this -> types[$i]))
			{
				$nb_ports += $this -> ports[$i];
	
				$table .= $this -> _intern_port_line($port_type, $type_cfg, $ports, $group, $register, $user, $secret, $tones, $hardware, $protocol, $start_ports, $nb_ports);

				$start_ports = $nb_ports + 1;
			}
		}

		return $table;
	}

/* PRI */
	function _get_pri_hardware_configuration ($pri_hdw, $pri_cfg, $port_type, $tab = "\t\t\t\t")
	{ 
		$options = array('te' => array( 'value' => 'TE', 'selected' => ' selected'),
				 'nt' => array( 'value' => 'NT', 'selected' => ''	  ));

		if ($this -> which_scenario == 3)
		{
			return $tab. "<input type='hidden' class='form-control input-sm $port_type' id='{$pri_hdw['id']}' name='{$pri_hdw['name']}' value='{$options['nt']['value']}'>\n";
		}

		if (isset($pri_cfg[$pri_hdw['name']]) && strcmp($pri_cfg[$pri_hdw['name']], 'NT') == 0)
		{
			$options['te']['selected'] = ''; 
			$options['nt']['selected'] = ' selected'; 
		}

		return $this -> _display_simple_select($pri_hdw, $options, $port_type);
	}

	function _get_pri_protocol_configuration ($pri_prtcl, $port_type)
	{
		$prtcl  = 'ptp';
		$ptp 	= array('ptp' => 'PTP', 'pmp' => 'PMP');

		return "\t\t\t\t<input type={$pri_prtcl['type']} class='form-control input-sm $port_type' name='{$pri_prtcl['name']}' id='{$pri_prtcl['id']}' value='{$ptp[$prtcl]}'>\n";
	}

	function _get_pri_protocol_t1e1_configuration ($pri_prtcl, $pri_cfg, $port_type)
	{
		$options = array('t1' => array( 'value' => 'T1', 'selected' => ' selected'),
				 'e1' => array( 'value' => 'E1', 'selected' => ''	  ));

		if (isset($pri_cfg[$pri_prtcl['name']]) && strcmp($pri_cfg[$pri_prtcl['name']], 'E1') == 0)
		{
			$options['t1']['selected'] = ''; 
			$options['e1']['selected'] = ' selected'; 
		}

		return $this -> _display_simple_select($pri_prtcl, $options, $port_type);
	}

	function _display_content_pri ($pri_cfg, $port_type = 'PRI')
	{
		// init viariables
		$name_pri_ports_modified = preg_replace('/\[\]/', '', $this -> pri_ports['name']);

		$group 		= ( isset($pri_cfg[$this -> pri_group['name']])   ? $pri_cfg[$this -> pri_group['name']] 		: '' 	 );
		$array_ports 	= ( isset($pri_cfg[$name_pri_ports_modified])	  ? explode('-', $pri_cfg[$name_pri_ports_modified])	: array());
		$tones		= ( isset($pri_cfg[$this -> pri_tones['name']])	  ? $pri_cfg[$this -> pri_tones['name']]		: ''	 );
		$country 	= ( isset($pri_cfg[$this -> pri_country['name']]) ? $pri_cfg[$this -> pri_country['name']]	 	: ''	 ); 
		$city	 	= ( isset($pri_cfg[$this -> pri_city['name']]) 	  ? $pri_cfg[$this -> pri_city['name']]	 		: '' 	 ); 
		$local	 	= ( isset($pri_cfg[$this -> pri_local['name']])   ? $pri_cfg[$this -> pri_local['name']] 		: '' 	 ); 

		// ports html string
		$ports_str = $this -> _display_ports_field ($pri_cfg, $array_ports , $port_type, $this -> pri_ports, 'isdn');

		// sip html string
		$sip_str = '';
		if ($this -> which_scenario == 2)
		{
			$user 	= ( isset($pri_cfg[$this -> pri_user['name']]) 	 ? $pri_cfg[$this -> pri_user['name']]	: ''); 
			$secret	= ( isset($pri_cfg[$this -> pri_secret['name']]) ? $pri_cfg[$this -> pri_secret['name']]: ''); 

			$sip_str = 	  "\t\t\t\t<input type='hidden' class='form-control input-sm $port_type' name='{$this -> pri_register['name']}' id='{$this -> pri_register['id']}' value='1'>\n"
					. $this -> _display_simple_field($port_type, $this -> pri_user['id']  , $this -> pri_user['name']  , $this -> pri_user['title']  , $this -> pri_user['type']  , $this -> pri_user['tooltip']  , $user  )
					. $this -> _display_simple_field($port_type, $this -> pri_secret['id'], $this -> pri_secret['name'], $this -> pri_secret['title'], $this -> pri_secret['type'], $this -> pri_secret['tooltip'], $secret);
		}

		// Select nt ot te
		$ntte_str = $this -> _get_pri_hardware_configuration($this -> pri_ntte, $pri_cfg, $port_type);

		// Select ptp or pmp
		$ptp_str = $this -> _get_pri_protocol_configuration ($this -> pri_ptp, $port_type);

		// Select t1 or e1
		$t1e1_str = (($this -> t1e1) ? $this -> _get_pri_protocol_t1e1_configuration($this -> pri_t1e1, $pri_cfg, $port_type) : '');

		// tones html string
		$tones_str = $this -> _display_tones($this -> pri_tones['id'], $this -> pri_tones['name'], $this -> pri_tones['title'], $this -> pri_tones['tooltip'], $port_type, $tones);

		// return html string
		return 	  $this -> _display_simple_field($port_type, $this -> pri_group['id']  , $this -> pri_group['name']  , $this -> pri_group['title']  , $this -> pri_group['type']  , $this -> pri_group['tooltip']  , $group   	 )
			. $ports_str
			. $sip_str
			. $ntte_str
			. $ptp_str
			. $t1e1_str
			. $tones_str
			. $this -> _display_simple_field($port_type, $this -> pri_country['id'], $this -> pri_country['name'], $this -> pri_country['title'], $this -> pri_country['type'], $this -> pri_country['tooltip'], $country	 )
			. $this -> _display_simple_field($port_type, $this -> pri_city['id']   , $this -> pri_city['name']   , $this -> pri_city['title']   , $this -> pri_city['type']   , $this -> pri_city['tooltip']   , $city	 )
			. $this -> _display_simple_field($port_type, $this -> pri_local['id']  , $this -> pri_local['name']  , $this -> pri_local['title']  , $this -> pri_local['type']  , $this -> pri_local['tooltip']  , $local	 );
	}

	function _get_validator_pri_inputs ()
	{		
		return 	  $this -> _get_validator_input_group($this -> pri_group['name'])
			. $this -> _get_validator_input_ports($this -> pri_ports['name'])
			. $this -> _get_validator_input_country($this -> pri_country['name'])
			. $this -> _get_validator_input_city($this -> pri_city['name'])
			. $this -> _get_validator_input_local($this -> pri_local['name']);
	}

/* BRI */
	function _get_bri_hardware_configuration ($isdn_hdw, $port_type, $which_side = 'extern', $tab = "\t\t\t\t")
	{
		$hdw  = 'te';
		$ntte = array('te' => 'te', 'nt' => 'nt');

		if (strcmp($which_side, 'extern') != 0 || $this -> which_scenario == 3)
		{
			$hdw = 'nt';
		}
		
		return $tab. "<input type={$isdn_hdw['type']} class='form-control input-sm $port_type' name='{$isdn_hdw['name']}' id='{$isdn_hdw['id']}' value='{$ntte[$hdw]}'>\n";
	}

	function _get_bri_protocol_configuration ($bri_prtcl, $bri_cfg, $port_type)
	{
		$options = array('ptp' => array( 'value' => 'PTP', 'selected' => ' selected'),
				 'pmp' => array( 'value' => 'PMP', 'selected' => ''	    ));

		if (isset($isdn_cfg[$bri_prtcl['name']]) && strcmp($bri_cfg[$bri_prtcl['name']], 'PMP') == 0)
		{
			$options['ptp']['selected'] = '';
			$options['pmp']['selected'] = ' selected';
		}

		return $this -> _display_simple_select($bri_prtcl, $options, $port_type);
	}

	function _display_content_extern_bri ($bri_cfg, $sip_str, $boolOnchange = false, $port_type = 'BRI')
	{
		// init viariables
		$name_bri_ports_modified = preg_replace('/\[\]/', '', $this -> bri_ports['name']);

		$group 		= ( isset($bri_cfg[$this -> bri_group['name']])   ? $bri_cfg[$this -> bri_group['name']] 		: ''	 );
		$array_ports 	= ( isset($bri_cfg[$name_bri_ports_modified])	  ? explode('-', $bri_cfg[$name_bri_ports_modified])	: array());
		$tones 		= ( isset($bri_cfg[$this -> bri_tones['name']])	  ? "[". $bri_cfg[$this -> bri_tones['name']] ."]"	: ''	 );
		$country 	= ( isset($bri_cfg[$this -> bri_country['name']]) ? $bri_cfg[$this -> bri_country['name']]	 	: ''	 ); 
		$city	 	= ( isset($bri_cfg[$this -> bri_city['name']]) 	  ? $bri_cfg[$this -> bri_city['name']]	 		: '' 	 ); 
		$local	 	= ( isset($bri_cfg[$this -> bri_local['name']])   ? $bri_cfg[$this -> bri_local['name']] 		: ''	 );

		// hardware and protocol configuration
		$ntte_str = $this -> _get_bri_hardware_configuration($this -> bri_ntte, $port_type);
		$ptp_str  = $this -> _get_bri_protocol_configuration($this -> bri_ptp , $bri_cfg  , $port_type);

		// ports html string
		$ports_str = $this -> _display_ports_field ($bri_cfg, $array_ports , $port_type, $this -> bri_ports, 'isdn', $boolOnchange);

		// tones html string
		$tones_str = $this -> _display_tones($this -> bri_tones['id'], $this -> bri_tones['name'], $this -> bri_tones['title'], $this -> bri_tones['tooltip'], $port_type, $tones);

		// return html string
		return	  $this -> _display_simple_field($port_type, $this -> bri_group['id']  , $this -> bri_group['name']  , $this -> bri_group['title']  , $this -> bri_group['type']  , $this -> bri_group['tooltip']  , $group	)
			. $ports_str
			. $sip_str
			. $ntte_str
			. $ptp_str
			. $tones_str
			. $this -> _display_simple_field($port_type, $this -> bri_country['id'], $this -> bri_country['name'], $this -> bri_country['title'], $this -> bri_country['type'], $this -> bri_country['tooltip'], $country	)
			. $this -> _display_simple_field($port_type, $this -> bri_city['id']   , $this -> bri_city['name']   , $this -> bri_city['title']   , $this -> bri_city['type']   , $this -> bri_city['tooltip']   , $city	)
			. $this -> _display_simple_field($port_type, $this -> bri_local['id']  , $this -> bri_local['name']  , $this -> bri_local['title']  , $this -> bri_local['type']  , $this -> bri_local['tooltip']  , $local	);
	}

	function _display_content_bri ($bri_cfg, $port_type = 'BRI', $port_type_lower = 'bri', $tab = "\t\t\t\t")
	{
		$sip_str	= '';
		$title_extern   = '';
		$intern_content = '';
		$boolOnchange   = false;

		if ($this -> which_scenario == 2)
		{
			// update Extern Content
			$boolOnchange = true;  
			$title_extern = $tab. "<p class='text-center h4'>". WIZARD_EXTERN_BRI_DIS ."</p>\n";

			$user   = ( isset($bri_cfg[$this -> bri_user['name']])   ? $bri_cfg[$this -> bri_user['name']]   : '' );
			$secret = ( isset($bri_cfg[$this -> bri_secret['name']]) ? $bri_cfg[$this -> bri_secret['name']] : '' );

			$sip_str = 	  $tab. "<input type='hidden' class='form-control input-sm $port_type' name='{$this -> bri_register['name']}' id='{$this -> bri_register['id']}' value='1'>\n"
					. $this -> _display_simple_field($port_type, $this -> bri_user['id']  , $this -> bri_user['name']  , $this -> bri_user['title']  , $this -> bri_user['type']  , $this -> bri_user['tooltip']  , $user  )
					. $this -> _display_simple_field($port_type, $this -> bri_secret['id'], $this -> bri_secret['name'], $this -> bri_secret['title'], $this -> bri_secret['type'], $this -> bri_secret['tooltip'], $secret);

			// create Intern Content
			$intern_content =   $tab. "<p class='text-center h4'>". WIZARD_INTERN_BRI_DIS ."</p>\n"
					  . $this -> _display_intern_table_ports($port_type, $bri_cfg, $this -> bri_ports, $this -> bri_group, $this -> bri_register, $this -> bri_user, $this -> bri_secret, $this -> bri_tones, $this -> bri_ntte, $this -> bri_ptp);
		}

		return $title_extern . $this -> _display_content_extern_bri($bri_cfg, $sip_str, $boolOnchange) . $intern_content;
	}	

	function _get_validator_bri_inputs ()
	{
		$ports_depends 	 = '';
		$ports_required  = '';

		if ($this -> which_scenario == 2)
		{
			$ports_depends = $this -> _get_port_depends ($this -> bri_ports['id'], $this -> bri_ports['name'], 'BRI');
		}
		else 	
		{
			$ports_required = $this -> _get_validator_input_ports($this -> bri_ports['name']);
		}

		return 	  $this -> _get_validator_input_group($this -> bri_group['name'], $ports_depends)
			. $ports_required
			. $this -> _get_validator_input_country($this -> bri_country['name'])
			. $this -> _get_validator_input_city($this -> bri_city['name'])
			. $this -> _get_validator_input_local($this -> bri_local['name']);
	}

/* GSM */
	function _display_content_gsm ($gsm_cfg, $port_type = 'GSM', $tab = "\t\t\t\t")
	{
		// init variables
		$name_gsm_ports_modified = preg_replace('/\[\]/', '', $this -> gsm_ports['name']);

		$group 		= ( isset($gsm_cfg[$this -> gsm_group['name']]) ? $gsm_cfg[$this -> gsm_group['name']] 			: ''	 );
		$array_ports 	= ( isset($gsm_cfg[$name_gsm_ports_modified])   ? explode('-', $gsm_cfg[$name_gsm_ports_modified])	: array());
		$tones		= ( isset($gsm_cfg[$this -> gsm_tones['name']]) ? $gsm_cfg[$this -> gsm_tones['name']]			: ''	 );

		// ports html string
		$ports_str = $this -> _display_ports_field($gsm_cfg, $array_ports , $port_type, $this -> gsm_ports, 'gsm');

		// sip string
		$sip_str = '';
		if ($this -> which_scenario == 2)
		{
			$user		= ( isset($gsm_cfg[$this -> gsm_user['name']])	? $gsm_cfg[$this -> gsm_user['name']]	: ''	 );
			$secret		= ( isset($gsm_cfg[$this -> gsm_secret['name']])? $gsm_cfg[$this -> gsm_secret['name']]	: ''	 );

			$sip_str =   $tab. "<input type='hidden' class='form-control input-sm $port_type' name='{$this -> gsm_register['name']}' id='{$this -> gsm_register['id']}' value='1'>\n"
		 		   . $this -> _display_simple_field($port_type, $this -> gsm_user['id']  , $this -> gsm_user['name']  , $this -> gsm_user['title']  , $this -> gsm_user['type']  , $this -> gsm_user['tooltip']  , $user  )
		 		   . $this -> _display_simple_field($port_type, $this -> gsm_secret['id'], $this -> gsm_secret['name'], $this -> gsm_secret['title'], $this -> gsm_secret['type'], $this -> gsm_secret['tooltip'], $secret);
		}

		return 	  $this -> _display_simple_field($port_type, $this -> gsm_group['id'], $this -> gsm_group['name'], $this -> gsm_group['title'], $this -> gsm_group['type'], $this -> gsm_group['tooltip'], $group)
			. $ports_str 
			. $sip_str;
	}

	function _get_validator_gsm_inputs ()
	{		
		return    $this -> _get_validator_input_group($this -> gsm_group['name'])
			. $this -> _get_validator_input_ports($this -> gsm_ports['name']);
	}

/* LTE */
	function _display_content_lte ($lte_cfg, $port_type = 'LTE', $tab = "\t\t\t\t")
	{
		// init variables
		$name_lte_ports_modified = preg_replace('/\[\]/', '', $this -> lte_ports['name']);

		$group 		= ( isset($lte_cfg[$this -> lte_group['name']]) ? $lte_cfg[$this -> lte_group['name']] 			: ''	 );
		$array_ports 	= ( isset($lte_cfg[$name_lte_ports_modified])   ? explode('-', $lte_cfg[$name_lte_ports_modified])	: array());
		$tones		= ( isset($lte_cfg[$this -> lte_tones['name']]) ? $lte_cfg[$this -> lte_tones['name']]			: ''	 );

		// ports html string
		$ports_str = $this -> _display_ports_field($lte_cfg, $array_ports , $port_type, $this -> lte_ports, 'lte');

		// sip string
		$sip_str = '';
		if ($this -> which_scenario == 2)
		{
			$user		= ( isset($lte_cfg[$this -> lte_user['name']])	? $lte_cfg[$this -> lte_user['name']]	: ''	 );
			$secret		= ( isset($lte_cfg[$this -> lte_secret['name']])? $lte_cfg[$this -> lte_secret['name']]	: ''	 );

			$sip_str =   $tab. "<input type='hidden' class='form-control input-sm $port_type' name='{$this -> lte_register['name']}' id='{$this -> lte_register['id']}' value='1'>\n"
		 		   . $this -> _display_simple_field($port_type, $this -> lte_user['id']  , $this -> lte_user['name']  , $this -> lte_user['title']  , $this -> lte_user['type']  , $this -> lte_user['tooltip']  , $user  )
		 		   . $this -> _display_simple_field($port_type, $this -> lte_secret['id'], $this -> lte_secret['name'], $this -> lte_secret['title'], $this -> lte_secret['type'], $this -> lte_secret['tooltip'], $secret);
		}

		return 	  $this -> _display_simple_field($port_type, $this -> lte_group['id'], $this -> lte_group['name'], $this -> lte_group['title'], $this -> lte_group['type'], $this -> lte_group['tooltip'], $group)
			. $ports_str 
			. $sip_str;
	}

	function _get_validator_lte_inputs ()
	{
		return    $this -> _get_validator_input_group($this -> lte_group['name'])
			. $this -> _get_validator_input_ports($this -> lte_ports['name']);
	}

/* FXO */
	function _display_content_fxo ($fxo_cfg, $port_type = 'FXO', $tab = "\t\t\t\t")
	{
		// init variables
		$name_fxo_ports_modified = preg_replace('/\[\]/', '', $this -> fxo_ports['name']);

		$group 		= ( isset($fxo_cfg[$this -> fxo_group['name']]) ? $fxo_cfg[$this -> fxo_group['name']] 			: ''	 );
		$array_ports 	= ( isset($fxo_cfg[$name_fxo_ports_modified])   ? explode('-', $fxo_cfg[$name_fxo_ports_modified])	: array());
		$tones		= ( isset($fxo_cfg[$this -> fxo_tones['name']]) ? $fxo_cfg[$this -> fxo_tones['name']]			: ''	 );

		// ports html string
		$ports_str = $this -> _display_ports_field($fxo_cfg, $array_ports , $port_type, $this -> fxo_ports, 'analog');

		// tones html string
		$tones_str = $this -> _display_tones($this -> fxo_tones['id'], $this -> fxo_tones['name'], $this -> fxo_tones['title'], $this -> fxo_tones['tooltip'], $port_type, $tones);

		// sip string
		$sip_str = '';
		if ($this -> which_scenario == 2)
		{
			$user		= ( isset($fxo_cfg[$this -> fxo_user['name']])	? $fxo_cfg[$this -> fxo_user['name']]	: ''	 );
			$secret		= ( isset($fxo_cfg[$this -> fxo_secret['name']])? $fxo_cfg[$this -> fxo_secret['name']]	: ''	 );

			$sip_str =   $tab. "<input type='hidden' class='form-control input-sm $port_type' name='{$this -> fxo_register['name']}' id='{$this -> fxo_register['id']}' value='1'>\n"
		 		   . $this -> _display_simple_field($port_type, $this -> fxo_user['id']  , $this -> fxo_user['name']  , $this -> fxo_user['title']  , $this -> fxo_user['type']  , $this -> fxo_user['tooltip']  , $user  )
		 		   . $this -> _display_simple_field($port_type, $this -> fxo_secret['id'], $this -> fxo_secret['name'], $this -> fxo_secret['title'], $this -> fxo_secret['type'], $this -> fxo_secret['tooltip'], $secret);
		}

		return 	  $this -> _display_simple_field($port_type, $this -> fxo_group['id'], $this -> fxo_group['name'], $this -> fxo_group['title'], $this -> fxo_group['type'], $this -> fxo_group['tooltip'], $group)
			. $ports_str 
			. $sip_str
			. $tones_str;
	}

	function _get_validator_fxo_inputs ()
	{
		return    $this -> _get_validator_input_group($this -> fxo_group['name'])
			. $this -> _get_validator_input_ports($this -> fxo_ports['name']);
	}

/* FXS */
	function _display_content_extern_fxs ($fxs_cfg, $port_type = 'FXS')
	{
		// init variables
		$name_fxs_ports_modified = preg_replace('/\[\]/', '', $this -> fxs_ports['name']);

		$group 		= ( isset($fxs_cfg[$this -> fxs_group['name']]) ? $fxs_cfg[$this -> fxs_group['name']] 			: ''	 );
		$array_ports 	= ( isset($fxs_cfg[$name_fxs_ports_modified])	? explode('-', $fxs_cfg[$name_fxs_ports_modified])	: array());
		$tones	 	= ( isset($fxs_cfg[$this -> fxs_tones['name']])	? $fxs_cfg[$this -> fxs_tones['name']]			: ''	 );

		// ports html string
		$ports_str = $this -> _display_ports_field($fxs_cfg, $array_ports, $port_type, $this -> fxs_ports, 'analog');

		// tones html string
		$tones_str = $this -> _display_tones($this -> fxs_tones['id'], $this -> fxs_tones['name'], $this -> fxs_tones['title'], $this -> fxs_tones['tooltip'], $port_type, $tones);

		// return html string
		return 	  $this -> _display_simple_field($port_type, $this -> fxs_group['id'], $this -> fxs_group['name'], $this -> fxs_group['title'], $this -> fxs_group['type'], $this -> fxs_group['tooltip'], $group)
			. $ports_str 
			. $tones_str;
	}

	function _display_content_fxs ($fxs_cfg, $port_type = 'FXS')
	{
		if ($this -> which_scenario == 2)
		{
			$title_intern = $tab. "<p class='text-center h4'>". WIZARD_INTERN_FXS_DIS ."</p>\n";
			$upload_file  =	  $tab. "<div class='form-group' style='text-align: center;'>\n"
					. $tab. "\t<label for='{$this -> fxs_csvfile['name']}' class='col-sm-2 control-label'>CSV File</label>\n"
					. $tab. "\t<div class='col-sm-4'>\n"
					. $tab. "\t\t<input type='file' id='{$this -> fxs_csvfile['id']}' name='{$this -> fxs_csvfile['name']}'>\n"
					. $tab. "\t</div>\n"
					. $tab. "\t<div class='col-sm-2'>\n"
					. $tab. "\t\t<input type='button' class='btn btn-default' name='upload' value='Upload' onclick='ajaxFileUploadFXSConfig();'>\n"
					. $tab. "\t</div>\n"
					. $tab. "</div>\n";

			return    $title_intern
				. $upload_file
				. $this -> _display_intern_table_ports($port_type, $fxs_cfg, $this -> fxs_ports, $this -> fxs_group, $this -> fxs_register, $this -> fxs_user, $this -> fxs_secret, $this -> fxs_tones);
		}

		return $this -> _display_content_extern_fxs($fxs_cfg);
	}

	function _get_validator_fxs_inputs ()
	{
		//TODO
		return '';
/*
		$ports_depends 	 = '';
		$ports_required  = '';

		if ($this -> which_scenario == 2)
		{
			$port_depends = $this -> _get_port_depends($this -> fxs_ports['id'], $this -> fxs_ports['name']);
		}
		else
		{
			$ports_required = $this -> _get_validator_input_ports($this -> fxs_ports['name']);
		}

		return    $this -> _get_validator_input_group($this -> fxs_group['name'], $port_depends)
			. $port_required;
*/	}

	// public
	function get_save_button ($port_type)
	{
		$lower_port_type = strtolower($port_type);

		return "<input type='button' id='{$this -> save_btn['id']}-$lower_port_type' name='{$this -> save_btn['name']}' value='{$this -> save_btn['value']}' onclick=\"ajaxManageModuleConfig('$port_type', 1);\">";
	}

	function get_update_button ($port_type)
	{
		$lower_port_type = strtolower($port_type);

		return "<input type='button' style='margin-left: 5px;' id='{$this -> updt_btn['id']}-$lower_port_type' name='{$this -> updt_btn['name']}' value='{$this -> updt_btn['value']}' onclick=\"ajaxManageModuleConfig('$port_type', 1);\">";
	}

	function get_remove_button ($port_type)
	{
		$lower_port_type = strtolower($port_type);

		return "<input type='button' style='margin-right: 5px;' id='{$this -> rmve_btn['id']}-$lower_port_type' name='{$this -> rmve_btn['name']}' value='{$this -> rmve_btn['value']}' onclick=\"ajaxManageModuleConfig('$port_type', 0);\">";
	}

	function get_content_modal ($pstn_cfg, $tab = "\t\t\t")
	{
		// init variables 
		$port_type_checked 	 = '';

		// display PSTN header
		$pstn_header = 	  $tab. "<div class='form-group group' id='{$this -> port_types['id']}'>\n"
				. $tab. "\t<label for='{$this -> port_types['name']}' class='col-sm-6 control-label'>{$this -> port_types['title']}</label>\n"
				. $tab. "\t<div class='col-sm-5'>\n";

		$html_content = '';
		foreach ($this -> list_port_types as $port_type) 
		{
			$checked = '';
			if (isset($pstn_cfg[$name_port_type_modified]) && strcmp($pstn_cfg[$name_port_type_modified], $port_type) == 0)
			{
				$port_type_checked = $port_type;	
				$checked 	   = ' checked';
			}

			if ($this -> which_scenario != 3 || preg_match('#BRI|PRI#', $port_type))
			{ 
				$pstn_header .= $tab. "\t\t<input type='radio' id='{$this -> port_types['id']}-". strtolower($port_type) ."' name='{$this -> port_types['name']}' value='$port_type' onclick=\"show_port('$port_type');\"$checked>$port_type\n";

				$html_content .=  $tab. "<div id='". $this -> _get_pstn_id_from_port_type($port_type) ."'". (strcmp($port_type_checked, $port_type) == 0 ? '' : " value='-1'") .">\n"
						. $this -> _display_content($pstn_cfg, $port_type)
						. $tab. "</div>\n"; 
			}
		}

		return	  $pstn_header
			. $tab. "\t</div>\n"
			. $tab. "</div>\n"
			. $html_content;
	}

	function get_general_javascript_code ($form)
	{
		ob_start();
?>
<script type="text/javascript">
	$(document).ready(
		function () { 
			$("div[value=-1]").hide();

			$('#<?php echo $form; ?>').validate({
				rules: {
					'<?php echo $this -> port_types['name']; ?>': {
						atLeastOnePort: true,
					},
<?php 
echo 	  (in_array('PRI', $this -> list_port_types) ? $this -> _get_validator_pri_inputs() : '')
	. (in_array('BRI', $this -> list_port_types) ? $this -> _get_validator_bri_inputs() : '')
	. (in_array('GSM', $this -> list_port_types) ? $this -> _get_validator_gsm_inputs() : '')
	. (in_array('LTE', $this -> list_port_types) ? $this -> _get_validator_lte_inputs() : '')
	. (in_array('FXO', $this -> list_port_types) ? $this -> _get_validator_fxo_inputs() : '')
	. (in_array('FXS', $this -> list_port_types) ? $this -> _get_validator_fxs_inputs() : '');
?>
        			},
                		highlight: function (element) {
                    			$(element).closest('.col-sm-3').addClass('has-error');
                    			$(element).closest('.form-group').addClass('has-error');
                		},
                		unhighlight: function (element) {
                    			$(element).closest('.col-sm-3').removeClass('has-error');
                	    		$(element).closest('.form-group').removeClass('has-error');
                		},
                		errorElement: 'span',
                		errorClass: 'help-block',
                		errorPlacement: function (error, element) {
					if (error.prop('id') === '<?php echo $this -> port_types['name']; ?>-error' || error.prop('id').slice(-13) === 'ports[]-error')
					{ 
                        			error.insertBefore(element);
					}
					else
					{
						error.insertAfter(element);
					}
                		}
			});
		}
	);

	function show_port (port_type)
	{
<?php		
		foreach ($this -> list_port_types as $port_type)
		{
			$id = $this -> _get_pstn_id_from_port_type($port_type);

			$array_hide = array_diff($this -> list_port_types, array($port_type));
?>
		if (port_type === '<?php echo $port_type; ?>')
		{
			$('#<?php echo $id; ?>').show();
<?php
			foreach ($array_hide as $hide_port_type)
			{
?>
			$('#<?php echo $this -> _get_pstn_id_from_port_type($hide_port_type); ?>').hide();
<?php
			}
?>
		}

<?php		} ?>
	}
<?php
		if ($this -> which_scenario == 2 && in_array('BRI', $this -> list_port_types))
		{
?>

	function switch_bri_port (port, extern)
	{
                var bool_checked = !($('#intern-<?php echo $this -> bri_ports['id']; ?>-' + port).prop('checked'));

                if (extern)
                {
                        bool_checked = $('#<?php echo $this -> bri_ports['id']; ?>-' + port).prop('checked');
                        $('#intern-<?php echo $this -> bri_ports['id']; ?>-' + port).prop('checked', !(bool_checked));
                }
                else
                {
                        $('#<?php echo $this -> bri_ports['id']; ?>-' + port).prop('checked', bool_checked);
                }

                $('#intern-<?php echo $this -> bri_user['id']; ?>-' + port).prop('disabled', bool_checked);
                $('#intern-<?php echo $this -> bri_secret['id']; ?>-' + port).prop('disabled', bool_checked);
                $('#intern-<?php echo $this -> bri_tones['id']; ?>-' + port).prop('disabled', bool_checked);

                if (bool_checked)
                {
                        $('#intern-<?php echo $this -> bri_group['id']; ?>-' + port).prop('value', '');
                        $('#intern-<?php echo $this -> bri_ntte['id']; ?>-' + port).prop('value', '');
                        $('#intern-<?php echo $this -> bri_ptp['id']; ?>-' + port).prop('value', '');
                }
                else
                {
                        $('#intern-<?php echo $this -> bri_group['id']; ?>-' + port).prop('value', 'BRI-intern' + port);
                        $('#intern-<?php echo $this -> bri_ntte['id']; ?>-' + port).prop('value', 'nt');
                        $('#intern-<?php echo $this -> bri_ptp['id']; ?>-' + port).prop('value', 'PMP');
                }
	}
<?php		} 

		if ($this -> which_scenario == 2 && in_array('BRI', $this -> list_port_types))
		{
?>

	function switch_fxs_port (port)
	{
                var bool_checked = !($('#intern-<?php echo $this -> fxs_ports['id']; ?>-' + port).prop('checked'));

                $('#intern-<?php echo $this -> fxs_user['id']; ?>-' + port).prop('disabled', bool_checked);
                $('#intern-<?php echo $this -> fxs_secret['id']; ?>-' + port).prop('disabled', bool_checked);
                $('#intern-<?php echo $this -> fxs_tones['id']; ?>-' + port).prop('disabled', bool_checked);
	}
<?php
		}

		$ajaxUploadFileScript = '';
		if ($this -> which_scenario == 2 && in_array('FXS', $this -> list_port_types))
		{
			$ajaxUploadFileScript = "<script type='text/javascript' language='javascript' src='./includes/js/ajaxfileupload.js'></script>\n";
?>

	function ajaxFileUploadFXSConfig() 
	{
		session();

		$.ajaxFileUpload(
		{
			url: "modules/Wizard/ajax-pstn-wizard.php",
			secureuri: false,
			fileElementId: "<?php echo $this -> fxs_csvfile['id']; ?>",
			dataType: "json",
			success: function (data, status)
			{
				if (typeof (data.error) != "undefined") {
					if (data.error != "") {
						alert(data.error);
					} else {
						var lines = data.file;
						lines = lines.split(";");
						$("input[name='intern_<?php echo $this -> fxs_ports['name']; ?>']").removeAttr("checked");
						$.each(lines, function (index, line) {
							var prop = line.split(",");
							$("#intern-<?php echo $this -> fxs_ports['id']; ?>-" + prop[0]).prop("checked", "checked");

							$("#intern-<?php echo $this -> fxs_user['id']; ?>-" + prop[0]).prop("value", prop[1]);
                					$('#intern-<?php echo $this -> fxs_user['id']; ?>-' + prop[0]).removeAttr('disabled');

							$("#intern-<?php echo $this -> fxs_secret['id']; ?>-" + prop[0]).prop("value", prop[2]);
                					$('#intern-<?php echo $this -> fxs_secret['id']; ?>-' + prop[0]).removeAttr('disabled');

							$("#intern-<?php echo $this -> fxs_tones['id']; ?>-" + prop[0] + " option[value='" + prop[3] + "']").prop("selected", true);
                					$('#intern-<?php echo $this -> fxs_tones['id']; ?>-' + prop[0]).removeAttr('disabled');
						});
					}
				}
			},
			error: function (data, status, e)
			{
				alert(e);
			}
		});

		return false;
	}
<?php
		}

		// nbAction == 0 -> delete ..... nbAction == 1 -> save
		if ($this -> which_scenario == 2)
		{
?>

	function ajaxManageModuleConfig (portType, nbAction)
	{
		session();

		var data_to_send;
 
		if (nbAction)
		{
			if ($("#Pstnform").validate({}).form() == true)
			{
				data_to_send = $("#Pstnform").serialize();
			}
			else
			{
				return false;
			}
		}
		else
		{
			data_to_send = {action:nbAction, port_types: portType};
		}

                $.ajax({
                        type: 'POST',
                        url: 'modules/Wizard/ajax-pstn-wizard.php',
                        data: data_to_send,
                        success: function (loadedData) {
                                $('.<?php echo $this -> class_btns; ?>.' + portType).html(loadedData);
                        },
                        failure: function (errMsg) {
                                alert(errMsg);
                        }
                });
	}
<?php
		}
?>
</script>
<?php
		return 	  $ajaxUploadFileScript
			. ob_get_clean();	
	}

	function get_multiple_form_javascript_code ($scenario)
	{
		if ($scenario == 2)
		{
			ob_start();
?>
			
		var multipleRmvNode = document.getElementsByName('<?php echo $this -> rmve_btn['name']; ?>');

		if (multipleRmvNode.length == 0)
		{
			alert('toto');
			return false;
		}

<?php
			return ob_get_clean();	
		}

		return '';
	}

	function organize_settings ($pstn_settings)
	{ 
		$settings = array();

		$settings['type'] = $pstn_settings[$port_types_name][0];
		unset($pstn_settings[$port_types_name]);
	
		$type = strtolower($settings['type']);
		foreach ($pstn_settings as $parameter => $value)
		{
			if (preg_match("/intern_". $type ."_[a-z_]*_([0-9])/", $parameter, $matches_port))
			{
				$parameter_modified = str_replace('intern_'. $type ."_", "", $parameter);

				$settings['intern'][$matches_port[1]][str_replace("_". $matches_port[1], "", $parameter_modified)] = $value;
			}
			else if (preg_match("/". $type ."_[a-z]*/", $parameter) && !(preg_match('/intern_/', $parameter)))
			{
				$parameter_modified = str_replace($type ."_", "", $parameter);

				$settings['extern'][$parameter_modified] = $value;
			}
		}

		return $settings;
	}

	function get_summary_settings($scenario, $pstn_settings, $tab = "\t\t\t")
	{
		// init variable
		$list_key_table = array('group'=> $this -> pri_group['title'], 'ports' => $this -> pri_ports['title'], 'tones' => $this -> pri_tones['title'], 'country'  => $this -> pri_country['title'] , 
					'city' => $this -> pri_city['title'] , 'local' => $this -> pri_local['title'], 'user'  => $this -> pri_user['title'] , 'register' => $this -> pri_register['title']);

		$title = $tab. "<p class='text-center h4'>". WIZARD_PSTN_SETTINGS_DIS ."</p>\n";
	
		// extern settings
		$extern_settings 	= '';
		if (isset($pstn_settings['extern']))
		{
			$title_extern_settings  = '';
			if ($scenario == 2 && isset($pstn_settings['intern']))
			{
				$title_extern_settings = $tab. "<p class='text-center h5'>". WIZARD_EXTERN_PSTN_SETTINGS_DIS ."</p>\n";
			}

			$th_line = '';
			$td_line = '';	
			foreach ($list_key_table as $key => $def)
			{
				if (isset($pstn_settings['extern'][$key]))
				{
					$th_line .= "<th>$def</th>";
					$td_line .= "<td>". (is_array($pstn_settings['extern'][$key]) ? implode('-', $pstn_settings['extern'][$key]) : $pstn_settings['extern'][$key]) ."</td>";
				}
			}

			$extern_settings = 	  $title_extern_settings
						. $tab. "<table class='table table-striped table-bordered'>\n"
						. $tab. "\t<tr>$th_line</tr>\n"
						. $tab. "\t<tr>$td_line</tr>\n"
						. $tab. "</table>\n";
		}
		
		// intern settings
		$intern_settings = '';
		if (isset($pstn_settings['intern']))
		{
			$intern_settings = 	  $tab. "<p class='text-center h5'>". WIZARD_INTERN_PSTN_SETTINGS_DIS ."</p>\n"
						. $tab. "<table class='table table-striped table-bordered'>\n"
						. $tab. "\t<tr><th>". $list_key_table['ports'] ."</th><th>". $list_key_table['user'] ."</th><th>". $list_key_table['tones'] ."</th></tr>\n";
				
			foreach ($pstn_settings['intern'] as $port => $parameters)
			{
				$intern_settings .= $tab. "\t<tr><td>$port</td><td>". $parameters['user'] ."</td><td>". $parameters['tones'] ."</td></tr>\n";
			}

			$intern_settings .= $tab. "</table>\n";
		}

		return $title . $extern_settings . $intern_settings;
	}
}
?>
